=== debian/changelog ===
bpftrace (0.21.2-2ubuntu3) plucky; urgency=low

  * Add symbol dumps for bpftrace and bpftrace-aotrt
    - d/helpers/dump_debug_symbols.sh: creates a shell script
      to be used in d/rules to dump the debug symbols of bpftrace
      and bpftrace-aotrt.
    - d/rules: uses the shell script created by the above patch to
      dump the debug symbols, which was not happening earlier due to
      exclusion from dh_strip and custom strip commands.
    (LP: #2069953)

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Thu, 14 Nov 2024 18:27:52 +0530

bpftrace (0.21.2-2ubuntu2) plucky; urgency=medium

  * Really link against shared LLVM (LP: #2086104)

 -- Mate Kukri <mate.kukri@canonical.com>  Thu, 07 Nov 2024 19:06:19 +0000

bpftrace (0.21.2-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/t/control: Run testsuite as autopkgtest (LP: #2052809)
    - Really do build the tests, we need them for autopkgtest
    - Disable two tests broken with Linux 6.10 (LP: #2073120)
    - Update failing tests
    - add xxd/pahole, needed to build tests
    - add patch to fix s390x and ppc64el build
    - add patch to fix armhf build failure
    - Use CI=true to skip test known to be failing on CI

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 12:02:16 +0100

bpftrace (0.21.2-2) unstable; urgency=medium

  * d/control: build-depends on unversioned clang. Closes: #1084067.
  * d/rules: static link with libbfd. Closes: #1008727.
  * d/patches: add upstream patch to workaround compilation error.
  * d/patches: add upstream patch for LLVM 19 support.
  * d/rules: disable dh_dwz.

 -- Vincent Bernat <bernat@debian.org>  Sat, 12 Oct 2024 21:08:39 +0200

bpftrace (0.21.2-1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/t/control: Run testsuite as autopkgtest (LP:2052809)
    - Build using LLVM 18.
    - Really do build the tests, we need them for autopkgtest
    - Add patch to fix underlinking of llvm-18
    - Update failing tests
    - Disable two tests broken with Linux 6.10 (LP: #2073120)
    - Ignore dwz errors on armhf
    - Use CI=true to skip test known to be failing on CI

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Jul 2024 14:59:44 +0200

bpftrace (0.21.2-1) unstable; urgency=medium

  * New upstream release.
  * d/copyright: fix src/resources/*.h entry.

 -- Vincent Bernat <bernat@debian.org>  Sun, 21 Jul 2024 16:41:16 +0200

bpftrace (0.21.0-1ubuntu6) oracular; urgency=medium

  * Update failing tests
  * Disable two tests broken with Linux 6.10 (LP: #2073120)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Tue, 16 Jul 2024 08:26:38 +0000

bpftrace (0.21.0-1ubuntu5) oracular; urgency=medium

  * Ignore dwz errors on armhf
  * Use CI=true to skip test known to be failing on CI
  * Ignore again some test failing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 13 Jul 2024 07:48:12 +0200

bpftrace (0.21.0-1ubuntu4) oracular; urgency=medium

  * Fix a build failure on armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 12 Jul 2024 21:52:04 +0200

bpftrace (0.21.0-1ubuntu2) oracular; urgency=medium

  * Fix a build failure on ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 12 Jul 2024 18:59:38 +0200

bpftrace (0.21.0-1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/t/control: Run testsuite as autopkgtest (LP:2052809)
    - Build using LLVM 18.
    - Really do build the tests, we need them for autopkgtest
    - Cherry pick upstream https://github.com/bpftrace/bpftrace/pull/3267 to
      fix FTBTFS on s390x
    - Add patch to fix underlinking of llvm-18

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 12 Jul 2024 14:19:01 +0200

bpftrace (0.21.0-1) unstable; urgency=medium

  * New upstream release.
    Fix CVE-2024-2313. Closes: #1071748.

 -- Vincent Bernat <bernat@debian.org>  Fri, 21 Jun 2024 20:47:59 +0200
