=== debian/tests/control ===
Test-Command: CI=true make -C $(find -name obj-*-linux-gnu)/ test
Depends: @builddeps@,
 linux-headers-generic,
 python-is-python3
Restrictions: allow-stderr, build-needed, needs-root, isolation-machine
