## bpftrace 0.22.1

=== debian/changelog ===
bpftrace (0.22.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Fri, 17 Jan 2025 22:38:09 +0100

bpftrace (0.21.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Sun, 22 Dec 2024 18:43:30 +0100
