=== debian/changelog ===
bpftrace (0.23.1-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Sun, 13 Apr 2025 17:46:24 +0200
