## bpftrace 0.23.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # bpftrace version number components.
 set(bpftrace_VERSION_MAJOR 0)
 set(bpftrace_VERSION_MINOR 23)
-set(bpftrace_VERSION_PATCH 1)
+set(bpftrace_VERSION_PATCH 2)
 
 include(GNUInstallDirs)
