=== src/cxxdemangler/CMakeLists.txt ===
add_library(cxxdemangler_stdlib STATIC cxxdemangler_stdlib.cpp)
add_library(cxxdemangler_llvm STATIC cxxdemangler_llvm.cpp)
