=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: bpftrace
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Vincent Bernat <bernat@debian.org>
+Maintainer: Vincent Bernat <bernat@debian.org>
 Standards-Version: 4.6.1
 Build-Depends: asciidoctor,
                bison,
@@ -23,9 +22,7 @@
                libiberty-dev,
                llvm-dev,
                systemtap-sdt-dev,
-               zlib1g-dev,
-               xxd,
-               pahole
+               zlib1g-dev
 Homepage: https://github.com/iovisor/bpftrace
 Vcs-Git: https://salsa.debian.org/debian/bpftrace.git
 Vcs-Browser: https://salsa.debian.org/debian/bpftrace
